From efbd360440b730260060f8648bd578bdde3ecadc Mon Sep 17 00:00:00 2001
From: Alex <dudesuchamazing@gmail.com>
Date: Fri, 12 May 2023 03:54:19 +0300
Subject: [PATCH] Fix double negative signs in mask/paste margin overrides.

---
 .githooks/pre-commit           | 50 +++++++++++++++++++++++++++++++++-
 common/widgets/unit_binder.cpp |  8 +++---
 2 files changed, 53 insertions(+), 5 deletions(-)
 mode change 120000 => 100644 .githooks/pre-commit

diff --git a/.githooks/pre-commit b/.githooks/pre-commit
deleted file mode 120000
index 84d936b2f1..0000000000
--- a/.githooks/pre-commit
+++ /dev/null
@@ -1 +0,0 @@
-hook-chain
\ No newline at end of file
diff --git a/.githooks/pre-commit b/.githooks/pre-commit
new file mode 100644
index 0000000000..dacab7579a
--- /dev/null
+++ b/.githooks/pre-commit
@@ -0,0 +1,49 @@
+#!/usr/bin/env bash
+#
+# Git "hook chain", used to execute multiple scripts per hook.
+# To use:
+#  * create a directory called <hookname>.d
+#  * add scripts to this directory (executable)
+#  * ln -s hook-chain <hookname>
+#
+# Now the scripts in that directory should be called in order.
+#
+# Set $HOOKCHAIN_DEBUG to see the names of invoked scripts.
+#
+# Based on script by Oliver Reflalo:
+# https://stackoverflow.com/questions/8730514/chaining-git-hooks
+#
+
+hookname=`basename $0`
+
+# Temp file for stdin, cleared at exit
+FILE=`mktemp`
+trap 'rm -f $FILE' EXIT
+cat - > $FILE
+
+# Git hooks directory (this dir)
+DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" >/dev/null && pwd )"
+
+# Execute hooks in the directory one by one
+for hook in $DIR/$hookname.d/*;
+do
+    if [ -x "$hook" ]; then
+
+        if [ "$HOOKCHAIN_DEBUG" ]; then
+            echo "Running hook $hook"
+        fi
+
+        cat $FILE | $hook "$@"
+        status=$?
+
+        if [ $status -ne 0 ]; then
+            echo "Hook $hook failed with error code $status"
+            echo "To commit anyway, use --no-verify"
+            exit $status
+        else
+            if [ "$HOOKCHAIN_DEBUG" ]; then
+                echo "Hook passed: $hook"
+            fi
+        fi
+    fi
+done
diff --git a/common/widgets/unit_binder.cpp b/common/widgets/unit_binder.cpp
index 24e375d1bd..3e879eacaa 100644
--- a/common/widgets/unit_binder.cpp
+++ b/common/widgets/unit_binder.cpp
@@ -120,9 +120,9 @@ UNIT_BINDER::~UNIT_BINDER()
         m_valueCtrl->Disconnect( wxEVT_SET_FOCUS, wxFocusEventHandler( UNIT_BINDER::onSetFocus ),
                               nullptr, this );
         m_valueCtrl->Disconnect( wxEVT_KILL_FOCUS, wxFocusEventHandler( UNIT_BINDER::onKillFocus ),
-                                 nullptr, this );
+                              nullptr, this );
         m_valueCtrl->Disconnect( wxEVT_LEFT_UP, wxMouseEventHandler( UNIT_BINDER::onClick ),
-                                 nullptr, this );
+                              nullptr, this );
     }
 }
 
@@ -364,7 +364,7 @@ void UNIT_BINDER::SetDoubleValue( double aValue )
                                                               setPrecision( displayValue, false ),
                                                               false, m_dataType );
 
-    if( displayValue == 0 && m_negativeZero )
+    if( displayValue == 0 && !std::signbit( displayValue ) && m_negativeZero )
         SetValue( wxT( "-" ) + textValue );
     else
         SetValue( textValue );
@@ -427,7 +427,7 @@ void UNIT_BINDER::ChangeDoubleValue( double aValue )
                                                               setPrecision( displayValue, false ),
                                                               false, m_dataType );
 
-    if( displayValue == 0 && m_negativeZero )
+    if( displayValue == 0 && !std::signbit( displayValue ) && m_negativeZero )
         ChangeValue( wxT( "-" ) + textValue );
     else
         ChangeValue( textValue );